library gen_fdc;
uses
  windows, messages, Shellapi;

type
  PwinampGeneralPurposePlugin =^TwinampGeneralPurposePlugin;
  TwinampGeneralPurposePlugin = packed record
    version:      integer;
    description:  PChar;
    init:         function:Integer;cdecl;
    config:       procedure;cdecl;
    quit:         procedure;cdecl;
    hwndParent:   HWND;
    hDllInstance: HINST;
  end;
const GPPHDR_VER=$010;
  wm_nid = wm_user + 203;
  id_1=102;
  id_2=103;
  AppName='FDC';
var
  NID : TNotifyIconData;
  Window : HWnd;
  fmod: twinampGeneralPurposePlugin;
{$R gen.res}
function WindowProc(Wnd: HWnd; Message, WParam: Word; LParam: Longint): Longint;stdcall;
var
  Menu, Menu1 : HMenu;
  PopUp : TPoint;
begin
  Result:=DefWindowProc(Wnd, Message, WParam, LParam);
  case Message of
    wm_Destroy: begin
                   PostQuitMessage(0);
                   Exit;
                   Result:=0;
                 end;
    wm_command : case LOWORD(wParam) of
                   id_1 : begin
  MessageBox(0,
             '   ',
             'About',
             MB_ICONINFORMATION);

                                exit;
                              end;
                   id_2 : begin
        //                       PostQuitMessage(0);
                               sendmessage(wnd,WM_CLOSE,0,0);
                               Exit;
                             end;
                 end;
    wm_nid : case lParam of
               wm_rbuttonup : begin

                                Menu := LoadMenu(hInstance, 'MENU');
                                Menu1 := GetSubMenu(Menu, 0);
                                GetCursorPos(PopUp);
                                TrackPopupMenu(Menu1, TPM_RIGHTALIGN or TPM_RIGHTBUTTON, PopUp.X, PopUp.Y, 0, Wnd, nil);
                                DestroyMenu(Menu1);
                                DestroyMenu(Menu);
                                exit;
                              end;
             end;
  end;

end;

procedure WinMainApi;stdcall;
const
  WindowClass : TWndClass = (style : cs_hredraw or cs_vredraw;
                             lpfnWndProc : @WindowProc;
                             cbClsExtra : 0;
                             cbWndExtra : 0;
                             hInstance : 0;
                             hIcon : 0;
                             hCursor : 0;
                             hbrBackground : COLOR_BTNFACE+1;
                             lpszMenuName : #0;
                             lpszClassName : AppName);
var
  Message: TMsg;

begin
  WindowClass.hInstance := HInstance;
  WindowClass.hIcon:=LoadIcon(HInstance, 'MAINICON');
  if Windows.RegisterClass(WindowClass) = 0
  then
    Halt(255);
  Window := CreateWindow(AppName, AppName, ws_overlappedwindow, 200, 200, 100, 200, 0, 0, HInstance, nil);
  ShowWindow(Window, Windows.sw_SHOW);
  with NID do
    begin
      uFlags := nif_icon or nif_tip or nif_message;
      cbSize := SizeOf(NID);
      Wnd := Window;
      szTip := AppName;
      hIcon := LoadIcon(HInstance, 'MAINICON');
      uCallBackMessage := wm_nid;
    end;
  Shell_NotifyIcon(nim_add, @NID);
  while GetMessage(Message, 0, 0, 0) do
    begin
      TranslateMessage(Message);
      DispatchMessage(Message);
    end;
  DestroyWindow(window);
  Shell_NotifyIcon(nim_delete, @NID);
end;


procedure config;cdecl;
begin
  MessageBox(0,
             '   ',
             'About',
             MB_ICONINFORMATION);
end;

function winampGetGeneralPurposePlugin:PwinampGeneralPurposePlugin;
begin
 Result:=@fmod;
end;
function init:Integer;cdecl;
begin
  result:=0;
  WinMainApi;
end;

procedure quit;cdecl
begin

end;
exports
  winampGetGeneralPurposePlugin;

begin
 fmod.version:=GPPHDR_VER;
 fmod.description:='FDC';
 fmod.init:=@init;
 fmod.config:=@config;
 fmod.quit:=@quit;
 fmod.hwndParent:=0;
 fmod.hDllInstance:=0;
end.

